澳门至尊网站-首页

您的位置:澳门至尊网站 > 程序编程 > 面向对象之

面向对象之

2019-10-29 04:37

周天多码文,前不久凌晨生龙活虎篇,明天再来风度翩翩篇:

在线编制程序:

在线预览:http://github.lesschina.com/python/base/oop/3.十分相关.html

代码裤子:

 

1.异常¶

1.1 try...except¶

又到了开新课的时候了,小明同学此次提前预习了知识,乘着老师还未有来就在黑板上写下了这段Code:

In [1]:

def main():
    try:
        1 / 0  # ZeroDivisionError: division by zero
    except ZeroDivisionError as ex:
        print(ex)


if __name__ == '__main__':
    main()

 

division by zero

 

1.2 try...except...else...finally¶

小潘同学刚走入就见到了,自语道:“try...except抓获至极何人不会?就能够这么屁点东西辛亏意思秀,切~ 作者给你把 格式补全”

于是乎乘着小明上厕所的时候,擦掉小明的Code,自身写了大器晚成段高大上的Code:

In [2]:

# 异常捕获全格式
def test(input_str):
    try:
        eval(input_str)
    except ZeroDivisionError as ex:
        print("except:", ex)
    else:
        print("else:没有异常就奖励100块~")
    finally:
        print("finally:小明是傻子~")


def main():
    test("1/0")
    print("-" * 10)
    test("print('小明啊小明你调坑里了~')")


if __name__ == '__main__':
    main()

 

except: division by zero
finally:小明是傻子~
----------
小明啊小明你调坑里了~
else:没有异常就奖励100块~
finally:小明是傻子~

 

当时小明和教育者一齐进去了,学子们隐隐间都听见小明的自夸声:“老师,小编可好了,提前预习並且还写了个demo在黑板上呢~”

教员豆蔻梢头进门看着黑板就笑了,学子们也笑成一片。小明心想,咦~难道我写错了?定眼意气风发看黑板,气呼呼的回座位了

else能够不写,但是大家 多数还是会写的,毕竟能够领悟是真的未有不当,实际不是遮挡了错误

1.3 多少个极度管理¶

导师很欣尉,感觉那一个班真有趣,我们学习空前热情,为了照顾小明,老师反问道:“有哪个人知道 四个可怜怎么管理?”

小明飞速的举手并把黑板上内容擦完,写下了如下代码:

In [3]:

# 多个异常捕获
def main():
    try:
        print(xiaopan)  # NameError: name 'xiaopan' is not defined
        1 / 0  # ZeroDivisionError: division by zero
    except NameError as ex:
        print(ex)
    except ZeroDivisionError as ex:
        print(ex)

if __name__ == '__main__':
    main()

 

name 'xiaopan' is not defined

 

教员问了小多美滋声,有多少个出口?

小明骄矜的说道:“五个,作者写了四个非常管理,当然都实践了”

学子们又笑了,小潘嘲谑的说了句:“生龙活虎看就知道二零一八年C#没好好学,那不都同生机勃勃嘛,相遇极度上边代码还实施呢?用血汗好好思虑”

当大家认为有些代码只怕会出错开上下班时间,就能够用try来运行这段代码,假诺实施出错,则三回九转代码不会继续实施,而是一贯跳转至except语句块,执行完except后,如果有finally语句块,则执行finally语句块

小明又难堪了。。。

1.4 多非常简写¶

老师再一次帮小明圆了个场:“已经非常不不难了,就是最终小得意的时候口误了,那小明同学你明白Python里面多特别有个方便写法吗?”

小明赶紧拿起粉笔刷刷刷的写完,然后说道:“of course

In [4]:

# 多个异常捕获的简写(注意哦,是元组哦)
def main():
    try:
        print(xiaopan)  # NameError: name 'xiaopan' is not defined
        1 / 0  # ZeroDivisionError: division by zero
    except (NameError, ZeroDivisionError) as ex:
        print(ex)


if __name__ == '__main__':
    main()

 

name 'xiaopan' is not defined

 

导师赶紧夸了夸小明,心想,哎呦喂终于把那难缠的东西弄回座位了。

小明走前还不要忘记说一句:“简写的时候注意格式哦,是 元组 不是逗号分隔”

师资那堂课超轻巧,大家都预习了同期内容也比较轻松。

随着以咨询的格局问道:“小潘同学,你精通那些的基类是怎么吧?借使要捕获全体极其该怎么办啊?”

小潘站起来讲道:“是BaseException

教育工俺扩展道:“全体的错误类型都无冕自BaseException,所以在采纳except时索要在乎的是,它不光捕获该项指标大谬不然,还把其子类也一只抓获了”

故而平时在抓获格外的时候 把子类分外放在日前,父类放在后边

看如下代码:

In [5]:

def main():
    try:
        1 / 0  # ZeroDivisionError: division by zero
    except BaseException as ex:
        print("base:", ex)
    except ZeroDivisionError as ex:
        print(ex)


if __name__ == '__main__':
    main()

 

base: division by zero

 

假设把父类放第三个,那么ZeroDivisionError积年累月也不会被推行了,其实你若是装了 代码规范提醒插件会唤醒您的

能够参见作者事先写的 vscode设置python3调节和测量检验情况的壮超过八分之四

来个通用非凡捕获的简写(官方不推荐使用简写):

In [6]:

# 直接except就行了
def main():
    try:
        1 / 0
        dnt += 1
    except:
        print("屏蔽错误")


if __name__ == '__main__':
    main()

 

屏蔽错误

 

教育工作者继续讲到,我们来看三个场景,未来无尽在线编辑器,你在她们那几个编辑框里写下了代码也可以有特别抛出的,那是怎么管理的啊?

微软有开源代码编辑器比较受接待(VSCode的一片段):monaco-editor

晋升一下,假设的确要做在线编辑器,记得思量一下fork炸弹,这一个实在也是很老的事物了,程序猿基本上都应该接触过了

1.5 抛出万分¶

作者们后续,像C#是用thorw抛出十分,那Python怎么 捕获异常后再抛出 呢?怎么自定义异常 呢?

接轨往下看:

In [7]:

# 捕获异常后再丢出,eg:在线运行的用户Code
def main():
    try:
        1 / 0  # ZeroDivisionError: division by zero
    except ZeroDivisionError as ex:
        print(ex)  # 写个日志,回头出问题可以深究
        raise


if __name__ == '__main__':
    main()

 

division by zero

 

---------------------------------------------------------------------------
ZeroDivisionError                         Traceback (most recent call last)
<ipython-input-7-15f01346e2d8> in <module>()
      9 
     10 if __name__ == '__main__':
---> 11main()

<ipython-input-7-15f01346e2d8> in main()
      2 def main():
      3     try:
----> 41 / 0  # ZeroDivisionError: division by zero
      5     except ZeroDivisionError as ex:
      6         print(ex)  # 写个日志,回头出问题可以深究

ZeroDivisionError: division by zero

In [8]:

# 抛出自定义异常
class DntException(BaseException):
    pass


def get_age(num):
    if num <= 0:
        raise DntException("num must>0")
    else:
        print(num)


def main():
    get_age(-1)
    get_age(22)  # 程序崩了,这句话不会被执行了


if __name__ == '__main__':
    main()

 

---------------------------------------------------------------------------
DntException                              Traceback (most recent call last)
<ipython-input-8-7c9dec6ec225> in <module>()
     17 
     18 if __name__ == '__main__':
---> 19main()

<ipython-input-8-7c9dec6ec225> in main()
     12 
     13 def main():
---> 14get_age(-1)
     15     get_age(22)  # 程序崩了,这句话不会被执行了
     16 

<ipython-input-8-7c9dec6ec225> in get_age(num)
      6 def get_age(num):
      7     if num <= 0:
----> 8raise DntException("num must>0")
      9     else:
     10         print(num)

DntException: num must>0

 

那二个这一块差不离讲罢了(logging模块后边会说)有如何补充的能够说的^_^

 

1.6 C#异常¶

小明又拓宽了C#的代码调换,怎么看皆感觉依然C#简单的讲啊,根本不用说吗,代码后生可畏贴就秒懂了。。。

In [1]:

%%script csharp
try
{
    Convert.ToInt32("mmd");
}
catch (Exception ex)
{
    // Input string was not in a correct format
    Console.WriteLine(ex.Message);
}

 

Input string was not in a correct format.

In [2]:

%%script csharp
//抛出自定义异常
try
{
    throw new Exception("出错了啊");
}
catch (Exception ex)
{
    Console.WriteLine(ex.Message);
}

 

出错了啊

 

您能够自定义特别类,承接Exception就能够,对了C#中间也有finally的

try
{
    throw new Exception("出错了啊");
    //Convert.ToInt32("mmd");
}
catch (Exception ex)
{
    // Input string was not in a correct format
    Console.WriteLine(ex.Message);
}
finally
{
    Console.WriteLine("finally");
}

现行有个别索要finally的地点超级多都被using(){}接管了,所以一定情景会选择

先这么了

本文由澳门至尊网站发布于程序编程,转载请注明出处:面向对象之

关键词: